#include <stdio.h>

//this file was written in Borland Turbo C++ 2.0 (yes, I know version 3 has
//syntax highlighting and without it, programming is pretty much a torture)

//OK byte 12..14 are "fmt" and then read 8 bytes more to get the number of channels
//then read 12 more bytes to get the bits per channel.

//yay globals
FILE * muuh;
FILE * out;
long period; //waste of RAM as this is most likely less than 255, but this way we don't have to convert between number formats and also we can be rather certain we have enough RAM to be this frivolous.
long lastperiod;
int bytecnt;
int blockcnt;

//I used to be able to define constants with #DEFINE TIMEOUT 4096. This version of C doesn't like that.

//ok when looking for a peak, it could be we are at a floating level or at
//another peak which may or may not have the same polarity.
//returns 0 for timeout, -1 for low, +1 for high
char look4peak(char ignoretimeout){ //no bools in C
	int i;
	unsigned char last;
	unsigned char curr;
	unsigned char min;
	unsigned char max;
	long peakpos1;
	long peakpos2;
	peakpos2=0;
	i=0;
	fgetpos(muuh, &peakpos1);
	last=getc(muuh);
	curr=getc(muuh);
	if(last>=128) { //positive peak, looking for a negative peak
	    //printf("DEBUG??1\n");
	    min=last-16;
	    while(curr>min && !feof(muuh)){ //get out of the sensitivity range
		if(ignoretimeout==0) i++;
		curr=getc(muuh);
		if(i>4096) {
		    printf("DEBUG: Timeout encountered.\n");
		    return 0;
		}
	    }
	    while(curr<=min && !feof(muuh)){
		if(ignoretimeout==0) i++;
		min=curr;
		curr=getc(muuh);
		if(i>4096) {
		    printf("DEBUG: Timeout encountered.\n");
		    return 0;
		}
	    }
	    //this code is abysmal, even for my standards - sooo much copy'n'paste...
	    //printf("DEBUG FALLING min=%i curr=%i\n",min,curr);
	    fgetpos(muuh, &peakpos2);
	    lastperiod=peakpos2-peakpos1;
	    if(period==0) {
		period=lastperiod;
		printf("DEBUG: Determined period =%i\n",period);
	    }

	    return -1;
	} else  { //negative peak, looking for a positive peak
	    //printf("DEBUG??2\n");
	    max=last+16;
	    while(curr<max && !feof(muuh)){ //get out of sensitivity range
		if(ignoretimeout==0) i++;
		curr=getc(muuh);
		if(i>4096) {
		    printf("DEBUG: Timeout encountered.\n");
		    return 0;
		}
	    }
	    while(curr>=max && !feof(muuh)){
		if(ignoretimeout==0) i++;
		max=curr;
		curr=getc(muuh);
		if(i>4096) {
		    printf("DEBUG: Timeout encountered.\n");
		    return 0;
		}
	    }
	    //printf("DEBUG RISING max=%i curr=%i\n",max,curr);
	    fgetpos(muuh, &peakpos2);
	    lastperiod=peakpos2-peakpos1;
	    if(period==0) {
		period=lastperiod;
		printf("DEBUG: Determined period =%i\n",period);
	    }

            return 1;
	}
}

//each block starts with a known value of 00 00 AA, so there's a bunch of
//cycles with known frequency, we use these to determine the period.
//Actually, we barely use these values... only to determine if it was 1 or 0.
char calibratebot(){
    //OK the header block has an average period of 35...
    //with a deviation of +-2. This is AWESOME! (also when I traced the values
    //in a hex editor, I guesstimated the period to be about 40)
    long fpold,fpcurr,fpsum;
    int fpdiv,i;
    char kalm;

    fpdiv=8; // ADJUST TO BYTE BOUNDARY (had it at 7, got 0x00 54)

    period=0; //throw it away
    fpsum=0;
    for(i=0; i<fpdiv; i++){
	fgetpos(muuh, &fpold);
	kalm=look4peak(0);
	if(kalm==0) {
	    printf("PANIK! (unless this is the end of the tape, then KALM)\n"); // might actually be end of tape!
	    return 1;
	}
	fgetpos(muuh, &fpcurr);
	printf("DEBUG period now=%u\n",fpcurr-fpold);
	fpsum+=fpcurr-fpold;
    }
    fpsum/=fpdiv;
    printf("Calibration period average:%i\n",fpsum);
    period=fpsum;
    return 0;
}

char readblock(){ //maybe read block, not just byte
    char peak;
    unsigned char decobyte;
    long halfperiod;
    long pftmin,pftmax,phtmin,phtmax;
    int i;

    //maybe I should calibrate BEFORE I calculate my tolerances?
    peak=calibratebot();
    if(peak==1) return 1;

    //I shouldn't calculate these per byte, but rather per block
    halfperiod=period/2;

    pftmin=period-(period/3); //33%tolerance
    pftmax=period+(period/3); //you know what? I rather bet the calibration goes towards the maximum.

    phtmin=halfperiod-(period/4);
    phtmax=halfperiod+(period/4);

    //note I'll probably stick a more or less arbitrary seeming amount of
    //look4peaks here to a) get better calibration and b) byte boundary align
    //the reading... The header of each block is 00 00 AA. If I have the wrong
    //amount of pre-reads, the result will get shifted.
    //what can happen? 01 55 (second byte could be 54 or 56)
    //02 A?
    //05 5?
    //other way... 00 55..., 2A, 15 and then we're back in sync (or nybblesync)

    do{
	//read one byte
	decobyte=0;
	for(i=0; i<8; i++){ 	//hm there's blocks where I get 2 AE 1A
				//and when I get 0 56 a6
	    peak=look4peak(0);
	    if(peak==0){
		printf("END OF BLOCK %i Bytes in Block: %i\n",blockcnt,bytecnt);
		bytecnt=0;
		peak=2;
		break;
	    }
	    if(lastperiod>pftmin && lastperiod<pftmax){
		//that was a zero
		decobyte&=0xFE; //make perfectly sure there are no surprises from a wayward overflow bit.
		decobyte<<=1;
	    }
	    else if(lastperiod>phtmin && lastperiod<phtmax){
		//that was a one - or rather half of one!
		decobyte|=1;
		decobyte<<=1;
		peak=look4peak(0);
		if(lastperiod>phtmax) {
		    if(period==0) {
			printf("DEBUG WTF?"); //never comes but the following error message shows period to be 0.
		    }
		    printf("ERROR! Read a 1 but it takes too long to close!\n");
		    printf("Block %i Byte %i Period %i Bitlength %i",blockcnt,bytecnt,period,lastperiod); //FIXME debug isn't working, period is always 0 even though it clearly isn't. (I can prove that with a if(period==0) printf("WTF\n"); line but the WTF never appears.
		    //notice how we're not returning? This is not a fatal error.
		}
            } else {
		if(period==0) {
		    printf("DEBUG WTF?");
		    if(feof(muuh)){
			printf("Premature end of file?\n");
			return 1;
		    }
		}
		printf("ERROR! Bit was way outside tolerance. Bitlength %i Period %i\n",lastperiod,period); //printf doesn't work, period is always 0
            }
	}
	if(bytecnt==0 && decobyte!=0){
	    //oh no we're shifted over! No clue why that's happening!
	    printf("Header error should be 0 got %x\n",decobyte);
	    do{
		fseek(muuh, -period, 1); //rewind so the next byte will be correct
		decobyte >>=1;
		decobyte&=0x7F;
	    } while(decobyte>0);
	    //the fact that I'm reading AA for the next byte is encouraging.
	}
	if(bytecnt==1 && decobyte!=0xAA){
	    //dammit we're shifted the other way. I would put that down to bad programming, but we get both shifts IN THE SAME FILE!
	    //even worse - when manually decoding this block, IT DOESN'T START WITH 00 AA!
	    printf("Header error should be AA got %x\n",decobyte);
	    do{
		printf("shifting...");
		fseek(muuh, -period, 1); //I don't understand why also here we need to go back... shouldn't we fast-forward? But now I'm getting the block to end with AA 00 (which I can confirm by decoding manually - but the start of the block is messed up)
		decobyte <<=1;
	    } while ((decobyte&128)!=128);
	    decobyte=0xaa; //cheat - ok we got 0 56 A6 A6, so the correct value would be 0 AD 5C... and AD isn't AA. Weird I'm getting 9E
	}
	if(peak<2){ //don't save last incomplete byte
	    bytecnt++;
	    printf(" %x",decobyte); //DEBUG do a hexdump
	    putc(decobyte, out);
	}

    } while(peak!=2);
    blockcnt++;

    return 0;

}


int main(int _argc, char* _argv[])
{
    unsigned char peak1val;
    unsigned char peak2val;
    unsigned char ch; //working with signed chars is easier, but the wave format is unsigned.
    char lastpeak;
    long filepos;

    period=0;
    lastperiod=0;
    bytecnt=0;
    blockcnt=0;

    if(_argc!=3){
	printf("This program needs an input and output file name.\n");
	printf("say decoread infile.wav outfile.bin\n\n");
	printf("Huh... err... Hello World? Sorry for reinventing the wheel badly,\n");
	printf("but I can't find the documentation, so I have to.\n");
	printf("What's this, you ask?\nIt's a program that will attempt to create a binary file\n");
	printf("from a DECO Cassette System tape dump. Say you have a wave file with the data in");
	printf("an analogueish format - I expect it to NOT be a square wave! The way I did it\n");
	printf("was to connect the read head of the DECO tape drive to the tape head of a\n");
	printf("shoebox cassette recorder and dumped it this way.\n");
	printf("So... say you have a wave file with this FM-encoded waveform.\n");
	printf("Just gimme its filename and I will attempt to make a binary.\n");
	//this program also assumes that 0 is a half cycle and 1 is a full cycle. Both take the same time.
	return 1;
    }
    muuh = fopen (_argv[1],"rb"); //read binary
    if(!muuh){
	printf("File not found\n");
	return 2;
    }

    //NOTE the way this file reads a wave file header is a textbook example
    //of how NOT to do it - it picks a few things and hopes they're right.
    //NOTE this will cause a lot of valid wave files to be discarded by this program
    fseek(muuh, 12, 0);

    if(getc(muuh)!='f' && getc(muuh)!='m' && getc(muuh)!='t'){
	printf("I don't like this file - where's the format string?\n");
	return 3;
    }

    fseek(muuh, 22, 0); //ok the relative position seek appears to not do what I want.
    if(getc(muuh)!=1){
	printf("I only accept mono files...\n");
	return 3;
    }
    fseek(muuh, 34, 0);
    if(getc(muuh)!=8){
	printf("I also need the bitdepth to be 8 bits...\n"); //when looking at the hex dump of a 16 bit wave, I couldn't make much sense out of it. The most significant byte wasn't changing by more than like... 3 (of 256) over the entire file even though it was normalized (meaning peak to peak was 65535)
	//wouldn't it've been nice if I had told you that *before*?
	return 3;
    }


    fseek(muuh, 44, 0);//sample area should start here...

    //here's where the state machine should go
    //int fgetpos(FILE *stream, fpos_t *pos);
    while(period==0 && lastpeak!=0){
	lastpeak=look4peak(1);
	if(period>4096) period=0;
    }
    //OK we got a working period now, start to decode...
    //TRAP: I know the first sensible peak it finds is just the "blub" at the start of the recording, it's a lone peak followed by more silence!
    lastpeak=look4peak(0);
    if(lastpeak==0){
	fgetpos(muuh, &filepos);
	printf("THOUGHT SO! fp=%u\n",filepos);
	period=0;
	lastpeak=1;
    }
    //else the next block will be skipped!
    while(period==0 && lastpeak!=0){
	lastpeak=look4peak(1);
	if(period>4096) period=0;
    }
    fgetpos(muuh, &filepos);
    printf("DEBUG file position now=%u\n",filepos); //NOTE here he found the first genuine wave. But the period is bullcrap
    out=fopen(_argv[2],"wb");


    //DEBUG just wanted to make sure that we're now at the beginning of the
    //first genuine block.
    //lastpeak=look4peak(0);
    //if(lastpeak==0) printf("Fuckfarts!\n");
    //fgetpos(muuh, &filepos);
    //printf("DEBUG filepos now=%u\n",filepos);

    do{
	lastpeak=readblock(); //uh oh here goes (OK after making the tolerances like 33% now it reads the header with no errors)
	if(lastpeak!=0) break; //oops end of file mid-block.
	lastpeak=look4peak(1);
    } while(lastpeak!=0);

    printf("DEBUG the program finished without crashing badly.\n");

    fclose(muuh); //oops why do I keep forgetting that?
    fclose(out);

    return 0;
}
